;**********************************************************************
;     2012.12.01      OK.                                                          *
;    Filename:        mV28FC.asm            *
;    Date:  2012.12.01                                                          *
;    File Version:                                                *
;                                                                     *
;    Author:                                                        *
;    Company:                                                         *
;       Ref  mVFC1.asmA12.8MHzpɈڐAB
; DSṔAmV10DA.asmgp邱ƁB@ʐMvgRwB	                                                        *
;**********************************************************************
;                                                                     *
;    Files required: P16F84A.INC                                      *
;                                                                     *
;		NbN	12.8MHz X'tal
;
;**********************************************************************
;                                                                     *
;    Notes:                
;  JX^}CY̎Ql
; PjTD7104P N1܂ 8 ̃vOBTD7104P/2,/4,/8\B
;      ύXꍇ́AuύXmv̍sCN*5.|Z̃Tu[`1<N<255ŗLB
; QjIF=Ԏg  łႢUSBLAg@ftHglƂĂ܂B
;      vZ IF_LSB=IF+3000A IF_CW=IF+800  ƂĂ邽߂łB
;    IF=9.000MHz̎    USBLAg8.9985MHZ 1HzPʂł
;
; SjLED\ ́A@ʂ̃Lbg@PIC16F819 DSP9\@mV10DA.asmŕ\܂B
;
;sATCFidENX^E̔z͏ȗj
;		( H:[qopen(LED̐ڑ̂݁j  L:[q2.4kGRDɗƂ)
;	ohbPUeWPX		LEDW[(A-F)
;	()̓sԍ
;	RA4(03)				VFO(Lo) input
;	RA3(02)				RA4ƐڑAgate toggle  
;	RA2(01)				gate=1000msec@pull-up, gate=200msec@pull-down
;	RA1(18)				ACK ;AcknowlegeM
;	RA0(17)				SERo
;		
;	RB7(13)			 IF USB/LSB/CW/AM      
;	RB6(12)			IF USB/LSB/CW/AM   
;
;	RB5(11)			heterodyne
;	RB4(10)			heterodyne	
;			3/2/1/0=No Offset/IF-Lo/ Lo+IF/ Lo-IF		Display
;	RB3(09)			Prescaler H:TD7104P=1   L:TD7104P=8
;
;	RB2(08)	Prescal N=32 or	 IF Frequency set; 8ʂ
;	RB1(07)	Prescal N=64 or	 IF Frequency
;	RB0(06)	Prescal N=128 or IF Frequency		
;	
;
;**********************************************************************


    list      p=16F84A             ; list directive to define processor
    #include <p16F84a.inc>         ; processor specific variable definitions

	errorlevel  -302              ; suppress message 302 from list file

    __CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _HS_OSC

; '__CONFIG' directive is used to embed configuration data within .asm file.
; The lables following the directive are located in the respective .inc file.
; See respective data sheet for additional information on configuration word.

#define		IN   	PORTA,4		;counter 
#define		TGL   	PORTA,3		;
#define		MK   	PORTA,0		; CW Buzzer
#define		SER   	PORTA,0		;Serial Data
#define		ACK   	PORTA,1		;ACK input

;***** VARIABLE DEFINITIONS
wait_cn		EQU	H'0C'
wait_cn2	EQU	H'0D'
ifdef0		EQU	H'0E'			;;RB6,7@load	
ifdef1		EQU	H'0F'			;
;   --------------- adress 10&H  
x0			EQU	H'10'	;X́AK #10h ԒnɒuĂ
x1			EQU	0x11
x2			EQU	0x12
x3			EQU	0x13
x4			EQU	0x14
if0			EQU	0x15	  	;IFg  IF_tab load
if1			EQU	0x16
if2			EQU	0x17
if3			EQU	0x18
vfo0		EQU	0x19		;Lo(VFO)B
vfo1		EQU	0x1A
vfo2		EQU	0x1B
vfo3		EQU	0x1C
vfo4		EQU	0x1D		
temp1		EQU	0x1E
dec00		EQU	0x1F		;8̏ʁAX\TopBOPTION
;   -------------- adress 20&H
dec0		EQU	0x20		; 10ii[ꏊiPOoCgj
dec1		EQU	0x21
dec2		EQU	0x22		;0.1kHz
dec3		EQU	0x23		;1kHz
dec4		EQU	0x24
dec5		EQU	0x25
dec6		EQU	0x26
dec7		EQU	0x27
dec8		EQU	0x28
dec9		EQU	0x29
ChekBit		EQU	0x2A	;ChekBit=B'1101' ;locate just after dec9
dot			EQU	0x2B	; dot 8bit	dec2,3,4,5,6,7,8,9Dotł@ex dec3,6@@B'01001000'	
oldec3		EQU	0x2C		
poi			EQU	0x2D		
mode		EQU	0x2E		;
val_m		EQU	0x2F		; ꎞ]i[ꏊiTu[`Ŏgpj
;    ------------- adress 30&H
val0		EQU	0x30		; ϊliRQrbgj
val1		EQU	0x31
val2		EQU	0x32
val3		EQU	0x33
val4		EQU	0x34
y0			EQU	0x35	
y1			EQU	0x36
y2			EQU	0x37
y3			EQU	0x38
overf		EQU	0x39
lasttm		EQU	0x3A		;value of the last TMR0
N			EQU	0x3B		;preccaler N=1,or 8  1<N<255
Ngate		EQU	0x3C		;Gate time multiple Ngate=5 or 1
length		EQU	0x3D
ccode		EQU	0x3E		
speed		EQU	0x3F		;spead=D'120' Xs[h́A{œKXύXB
;    ------------- adress 40&H
ct			EQU	0x40		;Sub counter
FrCw		EQU	0x41	;if FrCw=1, then CWanounce, else FrCw=0 and DSP Freq.Counter
History		EQU	0x42	;CW anounce 2 times after Power ON
FC			EQU	0x43	;FC=0 in case RA2=L when Power ON, Else FC=1
cn			EQU	0x44		
cs			EQU	0x45		;sub-counter 
ct0			EQU	0x46
CWON		EQU	0x47		;dRA1=Hł΁ACWON=D'1',else CWON=D'0'.CWAiEX̕B
;**********************************************************************
	ORG     0x000             ; processor reset vector
	goto    start              ; go to beginning of program

	ORG     0x004             ; interrupt vector location
; remaining code goes here

IF_tab	; IF Frequency
	addwf	PCL,1  		;cycle3
	retlw	H'24'		;if0	//IF0=15,998,500Hz=H'F4 1E 24'
	retlw	H'1E'		;if1		
	retlw	H'F4'		;if2	        
	retlw	H'00'		;if3
	;-------------
	retlw	H'24'		;if0	//IF1=7,998,500Hz=H'7A 0C 24'
	retlw	H'0C'		;if1		
	retlw	H'7A'		;if2	        
	retlw	H'00'		;if3
	;-------------
	retlw	H'8C'		;if0	//IF2=11,998,500Hz=H'B7 15 24'R1G11,996,300Hz=H'B7 0C 8C'
	retlw	H'0C'		;if1		
	retlw	H'B7'		;if2	        
	retlw	H'00'		;if3
	;-------------
	retlw	H'04'		;if0	//IF3=10,698,500Hz=H'A3 3F 04'
	retlw	H'3F'		;if1		
	retlw	H'A3'		;if2	        
	retlw	H'00'		;if3
	;-------------
	retlw	H'74'		;if0	//IF4=12,798,500Hz=H'C3 4A 24'R1;12,797,300Hz=H'C3 45 74'
	retlw	H'45'		;if1		
	retlw	H'C3'		;if2	        
	retlw	H'00'		;if3
	;-------------
	retlw	H'7C'		;if0	//IF5=453,500Hz=H'06 EB 7C'
	retlw	H'EB'		;if1		
	retlw	H'06'		;if2	        
	retlw	H'00'		;if3
	;-------------
	retlw	H'1C'		;if0	//IF6=11,273,500Hz=H'AC 05 1C'
	retlw	H'05'		;if1		
	retlw	H'AC'		;if2	        
	retlw	H'00'		;if3
	;-------------
	retlw	H'64'		;if0	//IF7=8,998,500Hz=H'89 4E 64'
	retlw	H'4E'		;if1		
	retlw	H'89'		;if2	        
	retlw	H'00'		;if3
	;-------------
	sleep

def_tab		; IF differencial frequency
	addwf	PCL,1  		;cycle3
	retlw	H'20'		;ifdef0	//0  RB7=L & RB6=L
	retlw	H'03'		;ifdef1	;800Hz=H'320';CW
	;	---------------------	
	retlw	H'DC'		;ifdef0	//1  RB7=L & RB6=H
	retlw	H'05'		;ifdef1	;1500HzH'5DC';AM
	;	---------------------	
	retlw	H'B8'		;ifdef0	//2  RB7=H & RB6=L
	retlw	H'0B'		;ifdef1	;3000Hz=H'BB8' ;LSB
	;	---------------------	
	retlw	H'00'		;ifdef0	//3  RB7=H & RB6=H
	retlw	H'00'		;ifdef1	;0Hz ;USB
	;	---------------------	
	sleep
presca_tab		; Prescaler Divided by N
	addwf	PCL,1  		;cycle3 ; 1<= N <=255
	retlw	D'8'		;poi=0/ Divided by N=8//TD7104P 
	retlw	D'1'		;poi=1/ Divided by N=1
	retlw	D'32'		;poi=2/ Divided by N=32
	retlw	D'64'		;poi=3/ Divided by N=64
	retlw	D'128'		;poi=4/ Divided by N=128
	;	---------------------	
	sleep

;  烂[Xւ̕ΐAu[XK@\tGL[̐A
;                          p121 CQ Mar.1998 JR7RAR  QƂB
;  Wbit code  1 0 1 0 0  1 0 0   ŏ̂T\  °°
;              			Ō̂R\ S
;                             ẮAubv\B
;   	1 0 1 1 0  1 1 1   V̏ꍇ́A6ڂ_ ° \u(v
;       0 0 1 1 0  1 1 0   6̏ꍇ́A6ڂZ_  \ uHv
CW_tab	addwf	PCL,1  		;cycle3==== ʏ탂[hAA BBBAA@BBI
		retlw	B'11111101'		;poi="0"
		retlw	B'01111101'		;poi="1"
		retlw	B'00111101'		;poi="2" 
		retlw	B'00011101'		;poi="3" 
		retlw	B'00001101'		;poi="4"
		retlw	B'00000101'		;poi="5"
		retlw	B'10000101'		;poi="6" 
		retlw	B'11000101'		;poi="7"	
		retlw	B'11100101'		;poi="8" 
		retlw	B'11110101'		;poi="9"
		retlw	B'01000011'		;poi="10"/ R;"."
		retlw	B'10000001'		;"e" g qh~
		retlw	B'10000001'		;"e" g qh~
		retlw	B'10000001'		;"e" g qh~
		retlw	B'10000001'		;"e" g qh~
		retlw	B'10000001'		;"e" g qh~
		retlw	B'10000001'		;"e" g qh~
		sleep
;CW_tab	addwf	PCL,1  		;cycle3=== ȗ[hBB
;		retlw	B'11111101'		;poi="0"
;		retlw	B'01000010'		;poi="1" gc[
;		retlw	B'00100011'		;poi="2" ggc[
;		retlw	B'00010100'		;poi="3" gggc[
;		retlw	B'00001101'		;poi="4"
;		retlw	B'00000101'		;poi="5"
;		retlw	B'10000101'		;poi="6" 
;		retlw	B'11000101'		;poi="7"	
;		retlw	B'11100101'		;poi="8" 
;		retlw	B'10000010'		;poi="9" c[g
;		retlw	B'01000011'		;poi="10"/ R;"."
;		retlw	B'10000001'		;"e" g qh~
;		retlw	B'10000001'		;"e" g qh~
;		retlw	B'10000001'		;"e" g qh~
;		retlw	B'10000001'		;"e" g qh~
;		retlw	B'10000001'		;"e" g qh~
;		retlw	B'10000001'		;"e" g qh~
;		sleep
;----------------------------------------------------------------------------

start	
		;temp TEST
	;	movlw	H'02'		;vfo=38,156,568Hz=H'02 46 39 18' 
	;	movwf	vfo3
	;	movlw	H'46'		
	;	movwf	vfo2
	;	movlw	H'39'
	;	movwf	vfo1
	;	movlw	H'18'
	;	movwf	vfo0
		
	;	movlw	B'01001111'		;temp ;DSP=vfox5 -(8998,500+1,500)
	;	movwf	mode			;temp ;DSP=	181,782,840=H'0A D5 C9 38'
	
	;	goto	main
		;temp	TEST

		clrf	CWON
		bsf		STATUS,5		;oN1
		movlw	B'00010110'		;ra.0=OUT -ra.1 IN 
		movwf	TRISA
		bcf		STATUS,5	;oN0
		clrf	PORTA
  ;-------------------
		bsf		STATUS,RP0	;oN1
		movlw	B'01100111'		;prescaler 1/256 set ;RBvAbv; オJEg	
		movwf	OPTION_REG	
		bcf		STATUS,RP0	;oN0

		;------------------xxx
start2
		bsf		STATUS,5		;oN1
		movlw	B'00010110'		;ra.0=OUT -ra.1 IN 
		movwf	TRISA			;trisa
		movlw	B'11111111'		;rb.0-rb.7IN !rb,#00000000	
		movwf	TRISB		;trisb
		bcf		STATUS,5	;oN0

		movlw	B'01001000'	;Dotʒu=01001000=567.890.123
		movwf	dot	

		movlw	D'1'
		btfss	ACK		;if ACK(Ra.1)=H during Power On, FrCW=D'1' else =D'0'
		movlw 	D'0'
		movwf	FrCw	

		clrf	FC

		clrf	PORTA
		clrf	PORTB

		movlw	H'E'
		movwf	dec00

		clrf	dec0
		clrf	dec1	
		clrf	dec2
		clrf	dec3
		clrf	dec4	
		clrf	dec5
		clrf	dec6
		clrf	dec7
		clrf	dec8
		clrf	dec9		
		clrf	TMR0		;TMR0NA

		movlw	B'00001101'		
		movwf	ChekBit

		movlw	D'5'	;Gate time multiple Ngate=5(0.2sec) or =1(1.0sec)
		movwf	Ngate

		movlw	D'2'
		movwf	History	;;CW anounce 2 times after Power ON		

		bsf		STATUS,5	;oN1
		clrwdt			;prescalerNA
		movlw	B'01100111'		;prescaler 1/256 set ;RBvAbv; オJEg	
		movwf	OPTION_REG	
		bcf		STATUS,5	;oN0
		bcf		SER

		movlw	D'255'		
		movwf	wait_cn
		call	wait_ms
		
main	
	
;++=========== ȉ USERɂā@KXύX@	=========================
		movlw	B'01001000'   	;dec7-dec6-dec5-dec4-dec3-dec2-dec1-dec0
		movwf	dot				;   0- dot-   0-   0- dot-   0-   0-   0    
		
		movlw	D'120'	;10 WPM at speed=120
		movwf	speed 
;++================ ύXӏ@܂ ===========================
		call	modeset
		call	FCchek		;Check for Diode between RA4 & RA5
		call	Ngate_set	;Gate Time multipled by 5 or 1
		call	N_set		;Prescaler set /N=1 or N=8
		call	IF_set		;IF frequency set
		clrf		vfo0
		clrf		vfo1
		clrf		vfo2
		clrf		vfo3	
		clrf		vfo4
		call	c_main		; Count /resulting vfo
		call	VFOcalc		;resulting actual VFO
		call	DSP_cal		;resulting dec0-dec9

		movlw	D'1'
		subwf	FrCw,0
		btfss	STATUS,Z	;if FrCw=1, then goto CWm
		goto	main1	;10DSPI@
		goto	CWm		;CW anouncementI

	;++ temp Displaying test +---
;	testmn	
	;	movlw	H'09'
	;	movwf	dec00

	;	movlw	H'08'
	;	movwf	dec0

	;	movlw	H'07'
	;	movwf	dec1
	
	;	movlw	H'06'
	;	movwf	dec2
	
	;	movlw	H'05'
	;	movwf	dec3

	;	movlw	H'04'
	;	movwf	dec4
	
	;	movlw	H'03'
	;	movwf	dec5
	
	;	movlw	H'02'
	;	movwf	dec6

	;	movlw	H'01'
	;	movwf	dec7
	
	;	movlw	H'00'
	;	movwf	dec8
	
	;	movlw	H'07'
	;	movwf	dec9

	;	movlw	B'01001000'
	;	movwf	dot	
	;++ temp test+---	

main1	;dot & dec00,dec1,dec3,dec5,dec7,dec9i8bit x 7filesj @dot-dec00- -dec9(4bit x 13 +B'1101')
		;[dec00`dec9]10word@@A56bit֕ϊ
		movlw	D'6'
		movwf	cn
main11	movlw	dec00
		movwf	FSR
main12	swapf	INDF,0	;<7-4>  <3-0>
		andlw	B'11110000'
		movwf	val_m
		incf	FSR,1
		movf	INDF,0		;W @INDF
		andlw	B'00001111'
		xorwf	val_m,1		;;<7-4>=dec00 ,,<3-0>=dec0
		decf	FSR,1
		movf	val_m,0
		movwf	INDF
		incf	FSR,1
		incf	FSR,1
		decfsz	cn,1
		goto	main12

	
main2	goto	Trans	;2cycle

	;====================
	;-------------------
CWm	;;;CW anounce
		movf	History,1
		btfsc	STATUS,Z	;if History=0, then Cwm2 
		goto	Cwm2
		decf	History,1
		goto	Cwm31

Cwm2	bsf		STATUS,5		;oN1
		movlw	B'00010110'		;ra.0=OUT -ra.1 IN 
		movwf	TRISA			;trisa
		bcf		STATUS,5	;oN0
		nop
		btfsc	ACK	;if RA1=L,then CW_anounce_ON, else goto main
		goto	main
Cwm31	movlw	D'3'		;dec4(100kHz),dec5,dec6-"."-dec7(0.1kHz) 4Digits CWo
		movwf	cn

		movlw	dec4
		movwf	FSR			;INDF	dec4
CWm32	movf	INDF,0		
		call	CW_tab
		movwf	ccode

		call	CWtrans
		incf	FSR,1
		decfsz	cn,1
		goto	CWm32

		movlw	D'10'		;;CW code="."
		call	CW_tab
		movwf	ccode
		call	CWtrans

		movlw	dec7		
		movwf	FSR			;INDF	dec7
		movf	INDF,0	
		call	CW_tab
		movwf	ccode
		call	CWtrans

		movlw	D'255'		;1b~Ԋu
		movwf	wait_cn
		call	wait_ms
		movlw	D'255'		
		movwf	wait_cn
		call	wait_ms
		movlw	D'255'		
		movwf	wait_cn
		call	wait_ms
		movlw	D'255'		
		movwf	wait_cn
		call	wait_ms

		goto	main
	;CWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW--------------------
CWtrans	
		movf	ccode,0
		andlw	B'00000111'
		movwf	length

		movf	ccode,0
		andlw	B'11111000'
		movwf	ccode

		movlw	D'0'
		subwf	length,0
		btfss	STATUS,Z
		goto	Ctrans0
		call	spce14		
		return
	;---------
Ctrans0	rlf		ccode,1
		btfsc	STATUS,C
		bsf		MK
		btfss	STATUS,C
		bcf		MK

		btfsc	STATUS,C
		call	mrk6
		btfss	STATUS,C
		call	mrk2
		call    spce2
		decfsz	length,1
		goto	Ctrans0
		call	spce6
		return
	;----------
spce14	call	spce1		;2003.6.23 C
		call	spce1
		call	spce1
		call	spce1
		call	spce1
		call	spce1
		call	spce1
spce8	call	spce1
		call	spce1
spce6	call	spce1
		call	spce1
spce4	call	spce1
		call	spce1
spce2	call	spce1
spce1	bcf		MK
		call	wait_mk	
		return
	;--------------------
mrk6	call	mrk1
		call	mrk1
mrk4	call	mrk1
		call	mrk1
mrk2	call	mrk1
mrk1		bsf		MK
		call	wait_beep		;output 1.2kHz pulse
	;	call	wait_mk			;output continuouse 
		return

	;-----------------------------
wait_beep
	;	goto	wait_mk	;1)continuouse  1) or 2)ꂩI
		goto	pwait_mk	;2);1200Hz Pulse

pwait_mk	;1.2kHz Pulse		 ;250 * (1+3)=1000sec
		bcf		STATUS,C
		rrf		speed,0
		movwf	wait_cn			; Default speed=#150/2=75
		nop	
pwtm1	bsf		MK
		movlw	D'250'	;1000cycle	 
		movwf	wait_cn2					
pwtm2	nop					;1cycle		
		decfsz	wait_cn2,1	;1cycle		
		goto	pwtm2		;2cycle

pwt1	bcf		MK
		movlw	D'250'	;1000cycle		 
		movwf	wait_cn2					
pwt2	nop					;1cycle		
		decfsz	wait_cn2,1	;1cycle		
		goto	pwt2		;2cycle

		decfsz	wait_cn,1		
		goto	pwtm1
		return			;	

wait_mk	;continuouse		 ;250 * (1+3)=1000sec
		movf	speed,0		; Default speed=#150
		movwf	wait_cn	
		nop	
wtm1	movlw	D'250'	;	 
		movwf	wait_cn2					
wtm2	nop					;1cycle	
		decfsz	wait_cn2,1	;1cycle			
		goto	wtm2		;2cycle
		decfsz	wait_cn,1		
		goto	wtm1
		return			;
	;CWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW-------------------- 
;-------------------------------------------
Trans	;Transmit dec0-dec9,dot to PIC16F819
	;dot & dec00,dec1,dec3,dec5,dec7,dec9i8bit x 7filesj @dot-dec00- -dec9(4bit x 13 +B'1101')

		bsf		SER	;	L	H,Gł@SER=H Ƃā@DSPAcknowlege CK(ACK)҂B
Tr1		movlw	D'56'		;1cycle
		movwf	cn			;1cycle

Tr2		btfss	dot,0		;2cycle
		bcf		STATUS,C
		btfsc	dot,0		;2cycle	
		bsf		STATUS,C
		rrf		dec9,1		;7cycle
		rrf		dec7,1
		rrf		dec5,1
		rrf		dec3,1
		rrf		dec1,1
		rrf		dec00,1
		rrf		dot,1

Tr11	btfss	ACK			;if ACK= LH, then Tr3
		goto	Tr11

Tr3		btfsc	STATUS,C	;2cycle
		bsf		SER		
		btfss	STATUS,C	;2cycle 
		bcf		SER
		
		movlw	D'20'	;T
		movwf	ct		;T
Tr5		decfsz	ct,1	;T ct=1ɂȂ@o	
		goto	Tr55	;T
		goto	Tr7		;T
Tr55	btfsc	ACK			;if ACK= HL, then Tr3	
		goto	Tr5

Tr6		decfsz	cn,1
		goto	Tr2
		bcf		SER		;H @L
Tr7		goto	main
	;;=======================---------------
; -------------------------------------------------------------------
modeset	
		bsf		STATUS,5	;oN1
		movlw	B'01100111'	;prescaler 1/256 set ;RBvAbv; オJEg	
		movwf	OPTION_REG	
		bcf		STATUS,5	;oN0


		bsf		STATUS,5	;oN1
		movlw	B'11111111'	;rb.0-rb.7IN !rb,#11111111b	
		movwf	TRISB		;trisb
		bcf		STATUS,5	;oN0
		clrf		PORTB

		movlw	D'1'
		movwf	wait_cn
		call		wait_ms

		movf	PORTB,0	
		movwf	mode
		return

FCchek 	clrf 	FC
		btfss	mode,4 	;RA4=H?
		return
		btfss	mode,5 	;RA5=H?
		return

		bsf		STATUS,5	;oN1	;Diode betwen RA4 and RA5 Check
		bcf		TRISB,5		; RA5	@Output
		bcf		STATUS,5	;oN0
		bcf		PORTB,5		;RA5=L
		nop
		btfss	PORTB,4
		goto	FC1
		clrf	FC		;FC=D'0'
		return

FC1		movlw	D'0'
		btfss 	mode,0
		movlw	D'1'
		btfss 	mode,1
		movlw	D'1'
		btfss 	mode,2
		movlw	D'1'
		movwf	FC
		return

Ngate_set
		movlw	D'1'
		btfss	PORTA,2		;if RA2=H(pull-up), then D=1 (Gate=1000msec)
		movlw	D'5'
		movwf	Ngate
		return

N_set		btfsc	FC,0	;if FC=D'1', then goto Ns1 
		goto	Ns1
		movlw	D'0'
		btfsc	mode,3		;if RB3=H(Open), then W=0 (N=prescaler=8)
		movlw	D'1'
		call	presca_tab
		movwf	N
		return

Ns1		movlw	D'0'
		btfss	mode,0
		movlw	D'2' 	;poi=2, N=32
		btfss	mode,1
		movlw	D'3' 	;poi=3  N=64
		btfss	mode,2
		movlw	D'4' 	;poi=3  N=128
		call	presca_tab
		movwf	N
		return

IF_set
		btfsc	FC,0		;if FC=0, then IFset not req. and return
		return
		movf	mode,0
		andlw	B'11000000'		;ifdef =RB7,6
		movwf	poi	
		swapf	poi,1
		bcf		STATUS,C 	;rotate 1 times (rrfx2 & rlfx1)
		rrf		poi,1
		movf	poi,0	
		call	def_tab
		movwf	ifdef0
		movwf	x0

		incf	poi,1	
		movf	poi,0	
		call	def_tab
		movwf	ifdef1
		movwf	x1
		clrf	x2
		clrf	x3
	;;;;+++++++++++
		movf	mode,0
		andlw	B'00000111'		;ifdef =RB2,1, 0
		movwf	poi	
		bcf		STATUS,C 	;multi by 4 
		rlf		poi,1
		bcf		STATUS,C 	;multi by 4 
		rlf		poi,1
		movf	poi,0
		call	IF_tab
		movwf	if0
		movwf	y0

		incf	poi,1
		movf	poi,0
		call	IF_tab
		movwf	if1
		movwf	y1

		incf	poi,1
		movf	poi,0
		call	IF_tab
		movwf	if2
		movwf	y2

		incf	poi,1
		movf	poi,0
		call	IF_tab
		movwf	if3
		movwf	y3
		call	add_xy	;(32bit)(32bit){y(32bit)@
		movf	x3,0		;
		movwf	if3

		movf	x2,0
		movwf	if2

		movf	x1,0
		movwf	if1

		movf	x0,0
		movwf	if0
		return		
	;--------------------
c_main
		movlw	D'5'
		subwf	Ngate,0
   		btfsc	STATUS,Z
		goto	c_m0.2g

		movlw	D'1'
		subwf	Ngate,0
   		btfsc	STATUS,Z
		goto	c_1m
;========================================
c_1m	movlw	D'250'	;gate time=1.0sec
		movwf	cn	

		bsf		STATUS,5	;oN1
		bsf		TRISA,3		;;ra.3 input mode=high impedance/TMR0̊Jn
		bcf		STATUS,5	;oN0
		clrf		lasttm
		clrwdt
		clrf		TMR0		;JE^TMR0NA,PSANA

;		sleep		;temp  1000 msec JEg̎n_
		;	;			;delay 2cycle			|	
c_1m1	call 	disp2cy		;(2+4659)*250=1,165,250	| 	
							;						|  		
		decfsz	cn,1		;249+2cycle				| 			
		goto 	c_1m1		;249*2					| 1,165,999cycle				
		;------------------------------------------------------------
		movlw	D'80'		;1+(3*79+2+2)=242    	|@
		movwf 	wait_cn		;1                  	| 
		call	wait_us 	;2cycle					|   245cycl 
		;------------------------------------------------------------
		movlw	D'250'		;1cycle					|
		movwf	cn			;1cycle					|
c_1m2	call 	disp2cy		;(2+4659)*250=1,165,250	| 	
							;						|  		
		decfsz	cn,1		;249+2cycle				| 			
		goto 	c_1m2		;249*2					| 1,166,001cycle  
		;------------------------------------------------------------
		movlw	D'78'		;1+(3*78+2+2)=239    	|@
		movwf 	wait_cn		;1                  	| 
		call	wait_us 	;2cycle					|   242cycl
		;------------------------------------------------------------
		movlw	D'186'		;1cycle					|
		movwf	cn			;1cycle					|
c_1m3	call 	disp2cy		;(2+4659)*186= 866,946	| 	
							;						|  		
		decfsz	cn,1		;185+2cycle				| 			
		goto 	c_1m3		;185*2					| 867,505cycle 
		;------------------------------------------------------------
		nop			;Ԓ							| 1 
		nop			;Ԓ							| 1 
		nop			;Ԓ							| 1 
		nop			;Ԓ							| 1 
	;												|   4cycle  
					;		 					(v3,199,996 step)  
c_1m4	nop			;Ԓ							| 1 
		nop			;Ԓ							| 1 
		nop			;Ԓ							| 1 (3)
		bsf		STATUS,5	;oN1					| 1
		bcf		TRISA,3	;trisa	ra.3 OUT;TMR0̒~ | 1 (2)
;	;	sleep		;temp  1000 msecJEg̏I_  (v3,200,000 step)
		bcf		STATUS,5	;oN0
		bcf		TGL
		goto	cmain2
;============================================
c_m0.2g	movlw	D'137'		;gate time=0.2sec
		movwf	cn	

		bsf		STATUS,5	;oN1
		bsf		TRISA,3		;;ra.3 input mode=high impedance/TMR0̊Jn
		bcf		STATUS,5	;oN0
		clrf		lasttm
		clrwdt
		clrf		TMR0		;JE^TMR0NA,PSANA

;		sleep		;temp  200 msec JEg̎n_
c_m0.2g2		;	;			;delay 2cycle			|	
		call 	display		;(2+4658)*137=638,420	| 	
							;						|  		
		decfsz	cn,1		;136+2cycle				| 			
		goto 	c_m0.2g2		;136*2				|638,830cycle				
		;------------------------------------------------------------
		movlw	D'255'		;1+(3*254+2+2)=767    	|@
		movwf 	wait_cn		;1                  	| 
		call	wait_us 	;2cycle					|   770cycle

		movlw	D'130'		;1+(3*129+2+2)=392    	|@
		movwf 	wait_cn		;1                  	| 
		call	wait_us 	;2cycle					|   395cycle

c_m0.2g3					;		 					(v639,995 step)  
		nop			;Ԓ							| 1
		nop			;Ԓ							| 1 (2)
		bsf		STATUS,5	;oN1					| 1
		bcf		TRISA,3	;trisa	ra.3 OUT;TMR0̒~ | 1 (2)
;	;	sleep		;temp  200msecJEg̏I_  (v640,000 step)
		bcf		STATUS,5	;oN0
		bcf		TGL
;============================================
cmain2	clrf	ct		;ct=1 in caes of TRM0=FF, else ct=0
		movlw	H'FF'		;Compensation when TMR0=FF,  
		subwf	TMR0,0
		btfss	STATUS,Z
		goto 	cmain5
cm21	;temp
		incf	ct,1	;;ct=1 in caes of TRM0=FF, 	
		movlw	D'140'	;TGL 140 times
		movwf	cn

cm22	bcf		TGL		;port Ra4̃gO
		nop
		bsf		TGL		;port Ra4̃gOオ@PSA@increment
		decfsz	cn,1
		goto	cm22

		movlw	D'140'	;TGL 140 times@again
		movwf	cn
cm23	bcf		TGL		;port Ra4̃gO
		nop
		bsf		TGL		;port Ra4̃gOオ@PSA@increment
		decfsz	cn,1
		goto	cm23

cmain5	call		dl5		;overflow check after last check
		nop
		movf 	TMR0,0		;TMR0datavfo[1]
		movwf	vfo1

		incf	vfo0,1
toggle	decf	vfo0,1
		bcf		TGL		;port Ra4̃gO
		nop
		bsf		TGL		;port Ra4̃gOオ@PSA@increment
		nop
		nop
		nop
		nop
		movf	TMR0,0
		subwf	vfo1,0	;vfo[1]-TMR0=0ł Z=1
		btfsc	STATUS,Z
		goto	toggle
		decf	vfo0,1	;vfo[0]ւ prescalerl̎荞݊B
		nop	

sub280	movf	ct,1	;if ct=0, then TMR0 not= FF and return 
		btfsc	STATUS,Z	
		return
		movlw	D'140'		;vfo= vfo- 140- 140
		subwf	vfo0,1
		movlw	D'1'		
		btfss	STATUS,C
		subwf	vfo1,1		
		btfss	STATUS,C		
		subwf	vfo2,1		
		btfss	STATUS,C
		subwf	vfo3,1	

		movlw	D'140'
		subwf	vfo0,1
		movlw	D'1'		
		btfss	STATUS,C
		subwf	vfo1,1		
		btfss	STATUS,C		
		subwf	vfo2,1		
		btfss	STATUS,C	
		subwf	vfo3,1		
		return

;------------------------------------
;------------------------------------
disp2cy	nop		;;4659steps =3993 +1 (return=2)
display			;;4658steps =665*7 +1 +2 (return=2)
		call	delay220			;2+663
		call	delay220			;2+663
		call	delay220			;2+663@Chek@TOIF@@@
		call	delay220			;2+663
		call	delay220			;2+663
		call	delay220			;2+663
		call	delay220			;2+663@Check TOIF
		nop							;1  Ԃ傤	
		return						;2     (=2)  
;--------------------------------------------
delay245	nop			;G645steps=261.0 usec̃[`------------
		nop
delay244	;------------------------G643steps=260.0 usec̃[`-----------664-
		nop					;1  Ԓ		|
		nop					;1  Ԓ		|
		nop					;1  Ԓ		|
		nop					;1  Ԓ		|

;	-----------------------------------------------------------------
delay220	;573+90=663step				
ch_tof1						;TMR0̃I[ot[(TOIF)̃`FbN[`---
		movlw	D'189'		;1+(3*188cycle +2+2)+4=573----------------------------
		movwf 	wait_cn		;1				 | 
		call	wait_us 	;2cycle		 	 |;(3-1)*3+ 1*2+ return2
		nop					;1  Ԓ		 |
delay90
ch_tof0	movlw	D'21'		;1+(20*3cycle+2+2)+25=90---------------------
		nop					;1cycle	 |	 	 |
		movwf 	wait_cn		;1cycle	 |	 	 |;(22-1)*3+ 1*2+ return2
		call	wait_us 	;2cycle   |      	 |
dl5		movf	INTCON,0	;1cycle	 |	 	 |
		movwf	overf		;1cycle	 |	 	 |
		movwf	lasttm		;1		 |tmr0lasttm when intcon,C overflow 	 |
		nop					;1		;|
		nop					;1		;
	;	;-----------------------	
		nop					;1cycle	 |	 	 |
		nop					;1cycle	 |	 	 |
		nop					;1cycle	 |	 	 |
		nop					;1cycle	 |	 	 |
		bcf		STATUS,C	;1cycle   |		 |
		movlw	D'1'		;1cycle	 |  25cy	 |
		btfsc	overf,2		;2cycle	 | 		 |
		addwf	vfo2,1		;0		 |		 |
		btfsc	STATUS,C	;2cycle	 |		 |
		addwf	vfo3,1		;0		 |		 |
		btfsc	overf,2		;2cycle	 |	 	 |
		bcf		INTCON,2	;0cycle 	 |      	 |
		nop					;1cycle	 |	 	 |
		nop					;1cycle	 |	 	 |
		return				;2cycle---------------
;;----------------------------------------------------------------- 
;;----------------------------------------------------------------- 
VFOcalc		;N=1@or 8 /Prescaler			;x[32bit]=vfo[32bit] * N[8bit]
		call	mult_vN		;VFON{Bx[3]-x[0]ɒ{VFOĂ.
		movf	x4,0		;
		movwf	vfo4

		movf	x3,0		;
		movwf	vfo3

		movf	x2,0
		movwf	vfo2

		movf	x1,0
		movwf	vfo1

		movf	x0,0
		movwf	vfo0

		movf	Ngate,0		;Gate time =0.2sec then multi by 5
		movwf	N
		call	mult_vN		;;x[32bit]=vfo[32bit] * N[8bit]
		movf	x4,0		;
		movwf	vfo4

		movf	x3,0		;
		movwf	vfo3

		movf	x2,0
		movwf	vfo2

		movf	x1,0
		movwf	vfo1

		movf	x0,0
		movwf	vfo0
		return
		;----------------

DSP_cal
		btfsc	FC,0		;if FC=1, then fctr <No@offset>
		goto	fctr
		btfss	mode,5		;if mode.5=L ,then het
		goto	het
		btfsc	mode,4		;if mode.4=H ,then fctr else reverse
		goto	fctr	;No offset
		goto	reverse

het		btfsc	mode,4		;if mode.4=H ,then lowhet
		goto 	lowhet

uphet		;			;disp=Lo-IF
		movf	if3,0		;y=IF
		movwf	y3
	
		movf	if2,0	
		movwf	y2	
	
		movf	if1,0
		movwf	y1

		movf	if0,0
		movwf	y0

		movf	vfo3,0		;x=Lo= vfo
		movwf	x3
	
		movf	vfo2,0
		movwf	x2
		
		movf	vfo1,0
		movwf	x1

		movf	vfo0,0
		movwf	x0


  		call  	sub_xy	;;(32bit)(32bit)|y(32bit)@
		goto	calc1

reverse					;disp=IF-Lo

		movf	if3,0		;x=IF
		movwf	x3
	
		movf	if2,0	
		movwf	x2	
	
		movf	if1,0
		movwf	x1

		movf	if0,0
		movwf	x0


		movf	vfo3,0		;y=Lo =vfo
		movwf	y3
		
		movf	vfo2,0
		movwf	y2
		
		movf	vfo1,0
		movwf	y1

		movf	vfo0,0
		movwf	y0

  		call  	sub_xy	;;(32bit)(32bit)|y(32bit)@
		goto	calc1
	
lowhet					;disp=Lo+IF
		movf	if3,0		;y=IF
		movwf	y3		;2013.01.20
	
		movf	if2,0	
		movwf	y2	
	
		movf	if1,0
		movwf	y1

		movf	if0,0
		movwf	y0

		movf	vfo3,0	;x=Lo =vfo
		movwf	x3		;2013.01.20
		
		movf	vfo2,0
		movwf	x2
		
		movf	vfo1,0
		movwf	x1

		movf	vfo0,0
		movwf	x0
	
  		call  	add_xy	;;(32bit)(32bit){y(32bit)@
		goto	calc1		

fctr					;PȂFreq. counter
		movf	vfo4,0
		movwf	x4

		movf	vfo3,0
		movwf	x3
		
		movf	vfo2,0	
		movwf	x2
	
		movf	vfo1,0
		movwf	x1

		movf	vfo0,0
		movwf	x0

calc1	
		movf	x4,0
		movwf	val4
	
		movf	x3,0
		movwf	val3

		movf	x2,0
		movwf	val2

		movf	x1,0
		movwf	val1

		movf	x0,0 
		movwf	val0 

		call	dcmain			;16i-10iϊ

		movlw	H'0A'
		btfsc	FC,0	;if FC=D'1', then dec9=0ah=[F]
		movwf	dec9
		return

;  ---------------------------------------------------------------
wait_us				;3 steps=1.2ʂ̃JEg
wait_us0	decfsz	wait_cn,1	;1cycle
		goto	wait_us0		;2cycle
		return

;
;		I[_[̃EFCg
;
wait_ms
wait_ms0
		movlw 	D'0'
		movwf	wait_cn2
wait_ms1
		nop	
		nop
		nop
		nop
		nop	
		nop
		nop
		
		decfsz	wait_cn2,1
		goto	wait_ms1

		decfsz	wait_cn,1
		goto	wait_ms0		

		return

;---------------------------------------------------------	
;	Z		(32bit)(32bit)|y(32bit)@
;
sub_xy
		movf	y0,0				;sub	x[0],y[0]
		subwf	x0,1
		movlw	1
		btfss	STATUS,C
		subwf	x1,1
		btfss	STATUS,C
		subwf	x2,1
		btfss	STATUS,C
		subwf	x3,1

		movf	y1,0				;sub	x[1],y[1];
		subwf	x1,1
		movlw	1
		btfss	STATUS,C
		subwf	x2,1
		btfss	STATUS,C
		subwf	x3,1

		movf	y2,0				;sub	x[2],y[2];
		subwf	x2,1		
								
		movlw	1
		btfss	STATUS,C
		subwf	x3,1
		
		movf	y3,0				;sub	x[3],y[3]
		subwf	x3,1								
		return
;--------------------------------------------------------------------
; 	Z	(32bit)(32bit){y(32bit)@
;
add_xy				
		movf	y0,0				;add	x[0],y[0]
		addwf	x0,1
		movlw	1
		btfsc	STATUS,C
		addwf	x1,1
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1
		
		movf	y1,0				;add	x[1],y[1]
		addwf	x1,1
								
		movlw	1
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1
		
		movf	y2,0				;add	x[2],y[2]	]
		addwf	x2,1
							
		movlw	1
		btfsc	STATUS,C
		addwf	x3,1

		movf	y3,0				;add	x[3],y[3]
		addwf	x3,1		
								
		return
;---------------------------------------------------------------------
;	SOrbgoCiPOiϊ
;
;	valɂSOrbgf[^uBi@val[4]:val[3]:val[2]:val[1]:va[0])
;
;	dcmainR[B
;
;	decɓi[B
;		(dec[0]:dec[1]:...:dec[8]:dec[9])
;		dec[0]ŏʌdec[9]ŉʌłB
;
;	ϊval͔j󂳂B
;
;	sample:
;		val	= 00:00:04:D2 h
;		dec	= 00:00:00:00:00:00:01:02:03:04
;                  dec(0):dec(1):(2):(3):(4):(5):(6):(7):(8):dec(9)
;						(1,234)
;
	

dcmain
		movlw	dec9		;	;mov	fsr,#dec_top		; i[ꏊl
		movwf	FSR
		incf	FSR,1
		call		devide			; ŉʕϊ 
		call		devide			;11JԂ
		call		devide
		call		devide
		call		devide

		call		devide
		call		devide
		call		devide
		call		devide
		call		devide
		call		devide			; ŏʕϊ
		
zeroblank
		movlw	D'4'		;**.*MHz\̑2܂blank\
		movwf	cn			;Zero Blanku

		movlw	dec00		;movlw  dec0		;mov	fsr,#20h		; dec[0]i[ꏊl
		movwf	FSR
zb1		movf	INDF,0
		btfss	STATUS,Z		;if dec[]=00, then continue, else return
		return
zb2			;if dec[]=00, then dec[]=0ehł́Ablank \ƂȂ
		movlw	H'0e'
		movwf	INDF	;movwf	indirect

		incf	FSR,1
		decfsz	cn,1
		goto	zb1
		return

;
;		POTu[`
;		POŏZ܂
;
devide		
		movlw	D'40'		;mov	cn,#32			; RQrbgԂ
		movwf	cn
		clrf		val_m
devide0		
		bcf		STATUS,C
		rlf		val0,1
		rlf		val1,1
		rlf		val2,1
		rlf		val3,1
		rlf		val4,1
		rlf		val_m,1
		
		movlw	B'11110110'
		addwf	val_m,0
		btfsc	STATUS,C
		movwf	val_m		;mov	val_m,w
		btfsc	STATUS,C
		incf	val0,1
		
		decfsz	cn,1		;djnz	cn,devide0
		goto	devide0
		decf	FSR,1
		movf	val_m,0		;mov	indirect,val_m		; ]
		movwf	INDF
		return
;----------------------------------------end of 10iϊ
;-----------------------------------------------------------------------
;	|Z		x[40bit]=vfo[32bit] * N[8bit]
;
;	vfo32rbgf[^uB
;		ivfo[3]:vfo[2]:vfo[1]:vfo[0]) 	vZߒ vfo4 g
;       N 8ޯްuB
;                 N ;  ő  #255łB
;
;	xɓi[B
;                ix[4]:x[3]:x[2]:x[1]:x[0]) 
;       		
;	ϊ N ͔j󂳂ȂB
;
;
mult_vN	clrf		x4
		clrf		x3
		clrf		x2
		clrf		x1
		clrf		x0
			
		movlw 	D'8'
		movwf 	cn
mult0		
		btfss	N,0
		goto	mutpas

		movf	vfo0,0				;add	x[0],vfo[0]
		addwf	x0,1
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x1,1
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1
		btfsc	STATUS,C
		addwf	x4,1

		movf	vfo1,0				;add	x[1],vfo[1]
		addwf	x1,1		
									
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1
		btfsc	STATUS,C
		addwf	x4,1

		movf	vfo2,0				;add	x[2],vfo[2]	
		addwf	x2,1		
									
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x3,1
		btfsc	STATUS,C
		addwf	x4,1

		movf	vfo3,0				;add	x[3],vfo[3]	
		addwf	x3,1

		movlw	D'1'
		btfsc	STATUS,C
		addwf	x4,1	

		movf	vfo4,0				;add	x[4],vfo[4]	
		addwf	x4,1		
		
mutpas	bcf		STATUS,C
		rlf		vfo0,1
		rlf		vfo1,1
		rlf		vfo2,1
		rlf		vfo3,1
		rlf		vfo4,1		;ǉ1
		btfsc	STATUS,C
		bsf		vfo0,0

		bcf		STATUS,C
		rrf		N,1
		btfsc	STATUS,C
		bsf		N,7

		decfsz	cn,1			;	djnz	cn,mult0
		goto	mult0

		movlw	D'8'
		movwf	cn
multrot	bcf		STATUS,C
		rrf		vfo4,1				;ǉ1
		rrf		vfo3,1
		rrf		vfo2,1
		rrf		vfo1,1
		rrf		vfo0,1
	;	btfsc	STATUS,C
	;	bsf		vfo3,7
		decfsz	cn,1			;djnz	cn,multrot
		goto 	multrot
		return
;---------------------------end of |Z

        END                       ; directive 'end of program'

